//==============================================================
// O[oϐ
float4x4 mW;		// [hs
float4x4 mP;		// ˉes
float4x4 mWV;		// [hr[
float4x4 mWVP;		// [hr[ˉe

float4 Diffuse;		// Cgƃ}eA̐F
float4 Specular;	// Cgƃ}eÃXyL
float4 Ambient;		// Cgƃ}eA
float Power;		// }eÃXyL̗
texture MeshTex;	// }eÃeNX`
float3 LightDir;	// Cg̕

float3 Eyepos;		// _̈ʒu

texture EnvTex;		// }bvL[ueNX`
float Reflection;	// }bv̔˗(0`1)

float2   vFog;		// (Far/(Far-Near), -1/(Far-Near))

int NoTexFlag;

//==============================================================
// eNX`Tv
//	EgpeNX`̃TvXe[gݒ

sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

samplerCUBE EnvSmp=sampler_state {
	Texture=<EnvTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// L[u}bsO
struct REFLECTVS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float4 Spe		: COLOR1;
	float2 MeshUV	: TEXCOORD0;
	float3 EnvUV	: TEXCOORD1;
	float Fog		: FOG;
};

// _VF[_
REFLECTVS_OUTPUT ReflectionVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	REFLECTVS_OUTPUT Out = (REFLECTVS_OUTPUT)0;
	
	// _WAeNX`W
	Out.Pos=mul(pos, mWVP);
	Out.MeshUV=mesh_uv;

	
	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)mW));
	Out.Col = Ambient + Diffuse*max(0, dot(-LightDir,w_normal));
	Out.Col.a = Diffuse.a;

	// XyL
	float3 Eye = normalize( Eyepos - mul( pos, mW ) );
	float3 r = -Eye + 2.0f * dot( w_normal, Eye ) * w_normal;
	Out.Spe = Specular * pow(max(0,dot(-LightDir,r)),Power);

	// L[ueNX`W
	Out.EnvUV=reflect(-Eye, w_normal);

	Out.Fog = vFog.x + Out.Pos.w * vFog.y;
	
	return Out;
}

// sNZVF[_
float4 ReflectionPS(REFLECTVS_OUTPUT In) : COLOR {
	return float4(( Reflection*texCUBE(EnvSmp, In.EnvUV).xyz + (1-Reflection)*tex2D(MeshSmp, In.MeshUV).xyz)*In.Col.xyz,In.Col.a) + In.Spe;
}

float4 ReflectionPS_NoTex(REFLECTVS_OUTPUT In) : COLOR {
	return float4(( Reflection*texCUBE(EnvSmp, In.EnvUV).xyz + (1-Reflection)*float3(1,1,1))*In.Col.xyz,In.Col.a) + In.Spe;
}

//==============================================================
// eNjbN

PixelShader PSArray[2] = { compile ps_2_0 ReflectionPS(),
							compile ps_2_0 ReflectionPS_NoTex()
							};

technique Reflection {
	pass P0 {
		VertexShader=compile vs_1_1 ReflectionVS();
		PixelShader=(PSArray[NoTexFlag]);//ps_2_0 ReflectionPS();
	}
}
;