//==============================================================
// O[oϐ
float4x4 mW;		// [hs
float4x4 mP;		// ˉes
float4x4 mWV;		// [hr[
float4x4 mWVP;		// [hr[ˉe

float4 Diffuse;		// Cgƃ}eA̐F
float4 Specular;	// Cgƃ}eÃXyL
float4 Ambient;		// Cgƃ}eA
float Power;		// }eÃXyL̗
texture MeshTex;	// }eÃeNX`
float3 LightDir;	// Cg̕

float3 Eyepos;		// _̈ʒu

float2   vFog;		// (Far/(Far-Near), -1/(Far-Near))

texture ShadowTex;
int SHADOW_TEX_SIZE;
float Margin;
float ShadowTexel;
float4x4 mLightWVP;
float4x4 mLightWVPB;
float ShadowPow=0.3;

//int AlphaTestFlag=0;
int NoTexFlag=0;

//==============================================================
// eNX`Tv
//	EgpeNX`̃TvXe[gݒ
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

sampler ShadowSmp=sampler_state {
	Texture=<ShadowTex>;
	MipFilter=POINT;
	MinFilter=POINT;
	MagFilter=POINT;
	AddressU=CLAMP;
	AddressV=CLAMP;
};

//==============================================================
// VF[_iVhE}bv̕`j

struct SHADOWMAPVS_OUTPUT
{
	float4 Pos		: POSITION;
	float2 Depth	: TEXCOORD0;
	float2 MeshUV	: TEXCOORD1;
};

// _VF[_
SHADOWMAPVS_OUTPUT ShadowMapVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	SHADOWMAPVS_OUTPUT Out = (SHADOWMAPVS_OUTPUT)0;

	// _WCgɑ΂Ďˉeϊ
	Out.Pos=mul(pos,mLightWVP);
	
	Out.MeshUV = mesh_uv;
	
	// [x
	Out.Depth.xy=Out.Pos.zw;
	
	return Out;
}

// sNZVF[_
float4 ShadowMapPS(SHADOWMAPVS_OUTPUT In) : COLOR {
	return In.Depth.x/In.Depth.y;
};
// sNZVF[_
float4 ShadowMapAlphaTestPS(SHADOWMAPVS_OUTPUT In) : COLOR {
	clip(tex2D(MeshSmp, In.MeshUV).a - 0.7f);	// ȂsNẐĂ

	return In.Depth.x/In.Depth.y;
};

//==============================================================
// VF[_iV[̕`j

struct SHADOWMAPSCENEVS_OUTPUT
{
	float4 Pos		: POSITION; 
	float4 Col		: COLOR0;
	float4 Spe		: COLOR1;
	float2 MeshUV	: TEXCOORD0; 
	float4 ShadowUV : TEXCOORD1; 
	float4 Depth	: TEXCOORD2;
	float Fog		: FOG;
};

// _VF[_
SHADOWMAPSCENEVS_OUTPUT ShadowMapSceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	SHADOWMAPSCENEVS_OUTPUT Out = (SHADOWMAPSCENEVS_OUTPUT)0;
	
	// _WAeNX`W
	Out.Pos=mul(pos, mWVP);
	Out.MeshUV=mesh_uv;

	// _WƖ@[hϊ
	float3 w_normal=normalize(mul(normal, (float3x3)mW));


	// _WCgɑ΂Ďˉeϊ
	Out.ShadowUV = mul(pos,mLightWVPB);
	Out.Depth=mul(pos, mLightWVP);
	
	Out.Col.rgb = Ambient.rgb + Diffuse.rgb*max(0, dot(-LightDir,w_normal));
	Out.Col.a = Diffuse.a;

	// XyL
	float3 Eye = normalize( Eyepos - mul( pos, mW ) );
	float3 r = -Eye + 2.0f * dot( w_normal, Eye ) * w_normal;
	Out.Spe = Specular * pow(max(0,dot(-LightDir,r)),Power);

	Out.Fog = vFog.x + Out.Pos.w * vFog.y;

	return Out;
}

// sNZVF[_
float4 ShadowMapScenePS(SHADOWMAPSCENEVS_OUTPUT In) : COLOR {
	// sNZCg͈͓̔ɂꍇ
	float4 cl = tex2D(MeshSmp, In.MeshUV)*In.Col+In.Spe;
	float2 xy=In.Depth.xy/In.Depth.w;
	if (abs(xy.x)<=1 && abs(xy.y)<=1 && In.Depth.z>=0) {

		// Cgɑ΂Ďˉeϊ_W
		// VhE}bṽeNX`Wɂ
		float2 uv=xy*0.5f+float2(0.5f,0.5f);
		uv.y=1-uv.y;

		// אڂ4eNZɊւ
		// Cg邩ǂ𔻒肷
		float z=In.Depth.z/In.Depth.w-Margin;
		float t0, t1, t2, t3;
		t0=(tex2D(ShadowSmp, uv).r<z).r?ShadowPow:1;
		t1=(tex2D(ShadowSmp, uv+float2(ShadowTexel, 0)).r<z)?ShadowPow:1;
		t2=(tex2D(ShadowSmp, uv+float2(0, ShadowTexel)).r<z)?ShadowPow:1;
		t3=(tex2D(ShadowSmp, uv+float2(ShadowTexel, ShadowTexel)).r<z)?ShadowPow:1;

		// 茋ʂ`Ԃ
		float2 f=frac(uv*SHADOW_TEX_SIZE);
		float light_power=lerp(
			lerp(t0, t1, f.x),
			lerp(t2, t3, f.x), 
			f.y);

		cl.rgb *= light_power;

	}
	return cl;
}

// sNZVF[_
float4 ShadowMapNoTexScenePS(SHADOWMAPSCENEVS_OUTPUT In) : COLOR {

	float4 cl = In.Col+In.Spe;
	if(tex2Dproj(ShadowSmp,In.ShadowUV).r < In.Depth.z / In.Depth.w - Margin){
		float2 xy=In.Depth.xy/In.Depth.w;
		float light_power=ShadowPow;
		light_power += max(xy.x*xy.x,xy.y*xy.y);
		light_power = min(1,light_power);
		cl.rgb *= light_power;
	}

	return cl;
}

//==============================================================
// eNjbN

//PixelShader ShadowMapPSArray[2] = {
//	compile ps_2_0 ShadowMapPS(),
//	compile ps_2_0 ShadowMapAlphaTestPS()
//};
technique ShadowMap {
	pass P0 {
		CullMode = NONE;
		Lighting=false;
		FogEnable=false;

		VertexShader=compile vs_2_0 ShadowMapVS();
		PixelShader=compile ps_2_0 ShadowMapPS();
	}
};
technique ShadowMapAlphaTest {
	pass P0 {
		CullMode = NONE;
		Lighting=false;
		FogEnable=false;

		VertexShader=compile vs_2_0 ShadowMapVS();
		PixelShader=compile ps_2_0 ShadowMapAlphaTestPS();
	}
};

PixelShader ShadowMapScenePSArray[2] = { 
	compile ps_2_0 ShadowMapScenePS(),
	compile ps_2_0 ShadowMapNoTexScenePS()
};
technique ShadowMapScene {
	pass P0 {
		VertexShader=compile vs_2_0 ShadowMapSceneVS();
		PixelShader=(ShadowMapScenePSArray[NoTexFlag]);
	}
};
